// core/types/vec2.h
#pragma once

namespace core
{
    namespace types
    {

        struct Vec2
        {
            float x{0}, y{0};

            Vec2() = default;
            Vec2(float _x, float _y) : x(_x), y(_y) {}

            Vec2 &operator+=(const Vec2 &o)
            {
                x += o.x;
                y += o.y;
                return *this;
            }
            Vec2 &operator-=(const Vec2 &o)
            {
                x -= o.x;
                y -= o.y;
                return *this;
            }

            friend Vec2 operator+(Vec2 a, const Vec2 &b) { return a += b; }
            friend Vec2 operator-(Vec2 a, const Vec2 &b) { return a -= b; }
        };

    }
}
